# Contributing to MSTest

Welcome, and thank you for your interest in contributing! Your contributions to open source, large or small, make projects like this possible.

There are many ways to contribute:

- [Submit issues](https://github.com/Microsoft/testfx/issues) and help verify fixes as they are checked in.
- Review the [source code changes](https://github.com/Microsoft/testfx/pulls).
- Contribute to the documentation.

## Creating Issues

- **DO** use a descriptive title that identifies the issue to be addressed or the requested feature.
- **DO** specify a detailed description of the issue or requested feature.
- **DO** provide the following for bug reports
  - Describe the expected behavior and the actual behavior. If it is not self-evident such as in the case of a crash, provide an explanation for why the expected behavior is expected.
  - Provide example code that reproduces the issue.
  - Specify any relevant exception messages and stack traces.
- **DO** subscribe to notifications for the created issue in case there are any follow up questions.

## Submitting Pull Requests

- **DO** ensure submissions pass all Azure DevOps legs and are merge conflict free.
- **DO** follow the [.editorconfig](http://editorconfig.org/) settings for each directory.
- **DO NOT** submit Pull Requests without having an approved feature request or enhancement.
- **DO NOT** submit large code formatting changes without discussing with the team first.

## Coding Style

The MSTest project follows the same rules as runtime repository [developer guide](https://github.com/dotnet/runtime/blob/main/docs/coding-guidelines/coding-style.md).
The repository includes [.editorconfig](http://editorconfig.org) files to help enforce this convention.
Contributors should ensure they follow these guidelines when making submissions.
