﻿// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT license. See LICENSE file in the project root for full license information.

namespace Microsoft.MSTestV2.CLIAutomation;

/// <summary>
/// Defines the defaults/constants used across different components.
/// </summary>
public static class Constants
{
    /// <summary>
    /// Name of data collection settings node in RunSettings.
    /// </summary>
    public const string DataCollectionRunSettingsName = "DataCollectionRunSettings";

    /// <summary>
    /// Name of RunConfiguration settings node in RunSettings.
    /// </summary>
    public const string RunConfigurationSettingsName = "RunConfiguration";

    public const string DataCollectorsSettingName = "DataCollectors";

    public const string RunSettingsName = "RunSettings";
}
